Index: fl_font_x.cxx
===================================================================
--- fl_font_x.cxx	(révision 9209)
+++ fl_font_x.cxx	(copie de travail)
@@ -17,6 +17,16 @@
 //
 #ifndef FL_DOXYGEN
 
+namespace {
+   const int SHRT_MAX = 32676;
+   const int SHRT_MIN = -32666;
+
+   int clip_to_short(int x, int y ) {
+    return ( x < SHRT_MIN || x > SHRT_MAX || y < SHRT_MIN || y > SHRT_MAX );
+   }
+}
+
+
 Fl_Font_Descriptor::Fl_Font_Descriptor(const char* name) {
   font = XCreateUtf8FontStruct(fl_display, name);
   if (!font) {
@@ -314,11 +324,12 @@
     font_gc = fl_gc;
     XSetFont(fl_display, fl_gc, font_descriptor()->font->fid);
   }
-  if (fl_gc) XUtf8DrawString(fl_display, fl_window, font_descriptor()->font, fl_gc, x, y, c, n);
+  if (fl_gc ) XUtf8DrawString(fl_display, fl_window, font_descriptor()->font, fl_gc, x, y, c, n);
 }
 
 void Fl_Xlib_Graphics_Driver::draw(int angle, const char *str, int n, int x, int y) {
   fprintf(stderr,"ROTATING TEXT NOT IMPLEMENTED\n");
+  if ( clip_to_short( x, y ) ) return;
   this->draw(str, n, (int)x, (int)y);
 }
 
@@ -327,7 +338,7 @@
     if (!font_descriptor()) this->font(FL_HELVETICA, FL_NORMAL_SIZE);
     font_gc = fl_gc;
   }
-  if (fl_gc) XUtf8DrawRtlString(fl_display, fl_window, font_descriptor()->font, fl_gc, x, y, c, n);
+  if (fl_gc ) XUtf8DrawRtlString(fl_display, fl_window, font_descriptor()->font, fl_gc, x, y, c, n);
 }
 #endif // FL_DOXYGEN
 //
